//
// dev.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// Device Manager
//

#ifndef DEV_H
#define DEV_H

struct dev;

#define DEV_TYPE_STREAM		1
#define DEV_TYPE_BLOCK		2

#define NODEV (-1)

#define IOCTL_GETBLKSIZE        1
#define IOCTL_GETDEVSIZE        2

typedef struct driver
{
  char *name;
  int type;

  int (*ioctl)(struct dev *dev, int cmd, void *args);
  int (*read)(struct dev *dev, void *buffer, size_t count, blkno_t blkno);
  int (*write)(struct dev *dev, void *buffer, size_t count, blkno_t blkno);
};

typedef struct dev 
{
  char *name;
  struct driver *driver;
  void *privdata;
  int refcnt;
};

extern struct dev *devtab[];
extern unsigned int num_devices;

struct dev *device(devno_t devno);
devno_t dev_make(char *name, struct driver *driver, void *privdata);
devno_t dev_open(char *name);
int dev_close(devno_t devno);
int dev_ioctl(devno_t devno, int cmd, void *args);
int dev_read(devno_t devno, void *buffer, size_t count, blkno_t blkno);
int dev_write(devno_t devno, void *buffer, size_t count, blkno_t blkno);

#endif
