//
// krnl.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//

#ifndef KRNL_H
#define KRNL_H

#include <types.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#include <bitops.h>
#include <rmap.h>

#include <os.h>

#include <os/tss.h>
#include <os/seg.h>
#include <os/pdir.h>
#include <os/pframe.h>
#include <os/kmem.h>
#include <os/kmalloc.h>
#include <os/vmm.h>

#include <os/syspage.h>

#include <os/pe.h>

#include <os/buf.h>

#include <os/object.h>
#include <os/sched.h>
#include <os/intr.h>

#include <os/pic.h>
#include <os/pit.h>

#include <os/pci.h>
#include <os/dev.h>

#include <os/video.h>
#include <os/kbd.h>

#include <os/vfs.h>
#include <os/dfs.h>

#include <os/mbr.h>
#include <os/pe.h>

#include <os/syscall.h>

// start.c

extern devno_t bootdev;

void panic(char *msg);
void exit();

// cons.c

extern devno_t consdev;

void init_cons();
void kprintf(const char *fmt, ...);

// null.c

extern devno_t nulldev;

void init_null();

// hd.c

void init_hd();

// devfs.c

void init_devfs();

// Intrinsic i/o functions

int __cdecl _inp(unsigned short);
unsigned short __cdecl _inpw(unsigned short);
unsigned long __cdecl _inpd(unsigned short);

int __cdecl outp(unsigned short, int);
unsigned short __cdecl _outpw(unsigned short, unsigned short);
unsigned long __cdecl _outpd(unsigned short, unsigned long);

#endif
