//
// hd.c
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// Harddisk driver
//

#ifndef MBR_H
#define MBR_H

#define MBR_SIGNATURE 0xAA55

#pragma pack(push)
#pragma pack(1)

struct disk_partition 
{
  unsigned char bootid;   // Bootable?  0=no, 128=yes
  unsigned char beghead;  // Beginning head number
  unsigned char begsect;  // Beginning sector number
  unsigned char begcyl;   // 10 bit nmbr, with high 2 bits put in begsect
  unsigned char systid;   // Operating System type indicator code
  unsigned char endhead;  // Ending head number
  unsigned char endsect;  // Ending sector number
  unsigned char endcyl;   // Also a 10 bit nmbr, with same high 2 bit trick
  unsigned int relsect;   // First sector relative to start of disk
  unsigned int numsect;   // Number of sectors in partition
};

struct master_boot_record 
{
  char bootstrap[446];
  struct disk_partition parts[4];
  unsigned short signature;
};

#pragma pack(pop)

#endif
