//
// pframe.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved
//
// Page frame database routines
//

#ifndef PFRAME_H
#define PFRAME_H

#define PFT_FREE 0
#define PFT_USED 1
#define PFT_SYS  2
#define PFT_BAD  3

struct pageframe
{
  unsigned short flags;
  unsigned short type;
  union
  {
    unsigned long locks;        // Number of locks
    unsigned long size;         // Size/buckets for kernel pages
    struct pageframe *next;     // Next free page frame for free pages
  };
};

extern struct pageframe *pfdb;

extern unsigned long freemem;
extern unsigned long totalmem;
extern unsigned long maxmem;

unsigned long alloc_pageframe(int type);
void free_pageframe(unsigned long pfn);
void init_pfdb(unsigned long heap, unsigned long memend);

#endif
