//
// syspage.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// System page defintions
//

#ifndef SYSPAGE_H
#define SYSPAGE_H

#define GDT_NULL    0
#define GDT_KTEXT   1
#define GDT_KDATA   2
#define GDT_UTEXT   3
#define GDT_UDATA   4
#define GDT_TSS     5
#define GDT_TIB     6

#define MAXGDT 7
#define MAXIDT 64

#define SEL_NULL    0
#define SEL_KTEXT   8
#define SEL_KDATA   16
#define SEL_UTEXT   24
#define SEL_UDATA   32
#define SEL_TSS     40
#define SEL_TIB     48

#define SEL_RPL0    0
#define SEL_RPL3    3

struct syspage
{
  struct tss tss;
  struct segment gdt[MAXGDT];
  struct gate idt[MAXIDT];
};

extern struct syspage *syspage;

#define OSBASE      0x80000000
#define PTBASE      0x90000000
#define SYSBASE     0x90400000
#define PFDBBASE    0x90800000
#define HTABBASE    0x91000000
#define KHEAPBASE   0x92000000

#define KHEAPSIZE   0x6E000000
#define HTABSIZE    0x01000000

#define SYSPAGE_ADDRESS (SYSBASE + 0 * PAGESIZE)
#define PAGEDIR_ADDRESS (SYSBASE + 1 * PAGESIZE)
#define INITTCB_ADDRESS (SYSBASE + 2 * PAGESIZE)
#define OSVMAP_ADDRESS  (SYSBASE + 4 * PAGESIZE)
#define VIDBASE_ADDRESS (SYSBASE + 5 * PAGESIZE)

#define TSS_ESP0 (SYSPAGE_ADDRESS + 4)

#endif
