//
// mod.h
//
// Copyright (c) 2001 Michael Ringgaard. All rights reserved.
//
// Module loader
//

#ifndef MOD_H
#define MOD_H

struct module
{
  hmodule_t hmod;
  char *name;
  char *path;
  struct module *next;
  struct module *prev;
  int refcnt;
};

void *get_proc_address(hmodule_t hmod, char *procname);
hmodule_t get_module_handle(char *name);
int get_module_filename(hmodule_t hmod, char *buffer, int size);
hmodule_t load_module(char *name);
void *get_entrypoint(hmodule_t hmod);

void init_modules(hmodule_t hmod, char *libpath);

#endif
